﻿/*
 * RestCustomerServiceCore.Controllers
 *
 * Author Michael Claudius, ZIBAT Computer Science
 * Version 1.0. 2018.09.10
 * Copyright 2018 by Michael Claudius
 * Revised ..
 * All rights reserved
 */

using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using RestCustomerServiceCore.Model;


namespace RestCustomerServiceCore.Controllers


//https://localhost:44395/api/customer using IISExpress
//https://localhost:5001/api/customer RestCustomerService local

{
    [Route("api/[controller]")]
    [ApiController]
    public class CustomerController : ControllerBase
    {
        public static int nextId = 0;

        private static List<Customer> cList = new List<Customer>()
        {    new Customer("Michael", "Kejser", 1961),
             new Customer("Ebbe", "Flod", 1968),
             new Customer("Peter", "Kanin", 1958),
             new Customer("Anders", "And", 1931),
             new Customer("Søren", "Kierkegaard", 1958),
             new Customer("King", "Khan", 1975)
        };



        // GET: api/Customer
        [HttpGet]
        public List<Customer> Get()
        {
            return cList;// 
        }

        // GET: api/Customer/5
        [HttpGet("{id}", Name = "Get")]
        public Customer GetCustomer(int id)
        {   // DOES NOT work
            
           Response.StatusCode = (int) HttpStatusCode.OK; //200  The message for the HttpResponse action
            
            Customer c = cList.FirstOrDefault(customer => customer.ID == id);
            //Set statuscode of response
            if (c==null) Response.StatusCode = (int) HttpStatusCode.NotFound;
            // Alternatively 
            // if (c == null) Response.StatusCode = 404;
            //Any number can be used for type casting, even customized numbers like 420

            return c;
        }

        // POST: api/Customer
        [HttpPost]
        public Customer InsertCustomer([FromBody] Customer customer)
            {
                customer.ID = CustomerController.nextId++;
                cList.Add(customer);
                return customer;
            }
      

        // PUT: api/Customer/5
        [HttpPut("{id}")]
        public Customer UpdateCustomer(int id, [FromBody] Customer customer)
        {
            //Find customer in the list replace old data with new; i.e. original ID is not changed
            //The original position in the list is kept
            Customer c = GetCustomer(id);
            if (c == null) return null;
            c.FirstName = customer.FirstName;
            c.LastName = customer.LastName;
            c.Year = customer.Year;
            return GetCustomer(id);

            //Or insert at index specified
            //cList.Insert(cList.IndexOf(c), customer);

            //Or delete and insert new customer with the old ID
            //The position in the list is changed to the be the last one
            //Customer oldCustomer = DeleteCustomer(id);
            //if (oldCustomer != null)
            //{
            //    customer.ID = oldCustomer.ID;
            //    cList.Add(customer);
            //}
            //return GetCustomer(id);

        }

        // DELETE: api/Customer/5
        [HttpDelete("{id}")]
        public Customer DeleteCustomer(int id)
        {
            Customer c = GetCustomer(id);
            if (c == null || c.ID < 3) return null;
            cList.Remove(c);
            return c;
        }
    }
}
